#include "includes.h"

/* ----------------------------------- found ------------------------------- */
void
found (const char *word, const char *chash, const char *ihash, const int mode)
{
	long int	sec, mili;
	int			rv;

	rv = getrusage (RUSAGE_SELF, &usage);
	if (rv == -1)
		error (1, errno, "found(): getrusage()");

	sec = usage.ru_utime.tv_sec + usage.ru_stime.tv_sec;
	mili = usage.ru_utime.tv_usec + usage.ru_stime.tv_usec;
	if (mili > 1000000)
		{
			sec++;
			mili -= 1000000;
		}
	
	printf ("\n***FOUND COLLISION IN ");
	switch (mode)
		{
			case 1:	printf ("MD5");	break;
			case 2:	printf ("SHA1");	break;
			default:	printf ("Unknown");	break;
		}
	printf (" HASH***\n");

	printf ("String:        \t%s\n", word);
	printf ("Computed HASH: \t%s\n", chash);
	printf ("Input HASH:    \t%s\n", ihash);
	printf ("Elapsed Time:  \t%li.%lis\n", sec, mili / 1000);
	
	
	exit (EXIT_SUCCESS);
}
/* ----------------------------------- digest2hash ------------------------- */
char *
digest2hash (const unsigned char *digest, const int mode)
{
	register int	j;
	static char		output[41];

/* We'll use a macro to convert with constant index,
	which will be faster then variable incrementation.

	for (i = 0; i < x; i++)
		{
			j = digest[i];
			output[i << 1] = fasthex[ (j >> 4) & 0x0f ];
			output[ (i << 1) + 1 ] = fasthex[j & 0x0f];
		}
	
	output[x << 1] = 0;
*/
	switch (mode)
		{
			case 1:
				convert (0);
				convert (1);
				convert (2);
				convert (3);
				convert (4);
				convert (5);
				convert (6);
				convert (7);
				convert (8);
				convert (9);
				convert (10);
				convert (11);
				convert (12);
				convert (13);
				convert (14);
				convert (15);
				output[32] = 0;
				break;
			case 2:
				convert (0);
				convert (1);
				convert (2);
				convert (3);
				convert (4);
				convert (5);
				convert (6);
				convert (7);
				convert (8);
				convert (9);
				convert (10);
				convert (11);
				convert (12);
				convert (13);
				convert (14);
				convert (15);
				convert (16);
				convert (17);
				convert (18);
				convert (19);
				output[40] = 0;
				break;
		}

	return output;
}
/*****************************************************************************/
void
do_one (void)
{
	uint16_t	x;
	uint16_t	i = 0;
	char		word[2] = "\0\0";
	
	printf ("Trying Word Length: 1\n");

	for (x = alphabet[i]; x; x = alphabet[++i])
		{
			word[0] = x;
			calculation (word);
		}
}
/*****************************************************************************/
void
do_two (void)
{
	uint16_t	one, two;
	uint16_t	i = 0;
	uint16_t	i_one = 0;
	uint16_t	i_two = 0;
	char		word[3] = "\0\0\0";

	printf ("Trying Word Length: 2\n");

	for (one = alphabet[i]; one; one = alphabet[++i_one])
		{
			for (two = alphabet[i]; two; two = alphabet[++i_two])
				{
					word[0] = one;
					word[1] = two;
					calculation (word);
				}
			i_two = 0;
		}
}
/*****************************************************************************/
void
do_three (void)
{
	register int	one, two, three;
	uint16_t	i = 0;
	uint16_t	i_one = 0;
	uint16_t	i_two = 0;
	uint16_t	i_three = 0;
	char		word[4] = "\0\0\0\0";

	printf ("Trying Word Length: 3\n");

	for (one = alphabet[i]; one; one = alphabet[++i_one])
		{
			for (two = alphabet[i]; two; two = alphabet[++i_two])
				{
					for (three = alphabet[i]; three; three = alphabet[++i_three])
						{
							word[0] = one;
							word[1] = two;
							word[2] = three;
							calculation (word);
						}
					i_three = 0;
				}
			i_two = 0;
		}
}
/*****************************************************************************/
void
do_four (void)
{
	register int			one, two, three, four;
	uint16_t	i = 0;
	uint16_t	i_one = 0;
	uint16_t	i_two = 0;
	uint16_t	i_three = 0;
	uint16_t	i_four = 0;
	char		word[5] = "\0\0\0\0\0";

	printf ("Trying Word Length: 4\n");

	for (one = alphabet[i]; one; one = alphabet[++i_one])
		{
			for (two = alphabet[i_two]; two; two = alphabet[++i_two])
				{
					for (three = alphabet[i_three]; three; three = alphabet[++i_three])
						{
							for (four = alphabet[i_four]; four; four = alphabet[++i_four])
								{
									word[0] = one;
									word[1] = two;
									word[2] = three;
									word[3] = four;
									calculation (word);
								}
							i_four = 0;
						}
					i_three = 0;
				}
			i_two = 0;
		}
}
/*****************************************************************************/
void
do_five (void)
{
	uint16_t	one, two, three, four, five;
	uint16_t	i = 0;
	uint16_t	i_one = 0;
	uint16_t	i_two = 0;
	uint16_t	i_three = 0;
	uint16_t	i_four = 0;
	uint16_t	i_five = 0;
	char		word[6] = "\0\0\0\0\0\0";

	printf ("Trying Word Length: 5\n");

	for (one = alphabet[i]; one; one = alphabet[++i_one])
		{
			for (two = alphabet[i]; two; two = alphabet[++i_two])
				{
					for (three = alphabet[i]; three; three = alphabet[++i_three])
						{
							for (four = alphabet[i]; four; four = alphabet[++i_four])
								{
									for (five = alphabet[i]; five; five = alphabet[++i_five])
										{
											word[0] = one;
											word[1] = two;
											word[2] = three;
											word[3] = four;
											word[4] = five;
											calculation (word);
										}
									i_five = 0;
								}
							i_four = 0;
						}
					i_three = 0;
				}
			i_two = 0;
		}
}
/*****************************************************************************/
void
do_six (void)
{
	uint16_t	one, two, three, four, five, six;
	uint16_t	i = 0;
	uint16_t	i_one = 0;
	uint16_t	i_two = 0;
	uint16_t	i_three = 0;
	uint16_t	i_four = 0;
	uint16_t	i_five = 0;
	uint16_t	i_six = 0;
	char		word[7] = "\0\0\0\0\0\0\0";

	printf ("Trying Word Length: 6\n");

	for (one = alphabet[i]; one; one = alphabet[++i_one])
		{
			for (two = alphabet[i]; two; two = alphabet[++i_two])
				{
					for (three = alphabet[i]; three; three = alphabet[++i_three])
						{
							for (four = alphabet[i]; four; four = alphabet[++i_four])
								{
									for (five = alphabet[i]; five; five = alphabet[++i_five])
										{
											for (six = alphabet[i]; six; six = alphabet[++i_six])
												{
													word[0] = one;
													word[1] = two;
													word[2] = three;
													word[3] = four;
													word[4] = five;
													word[5] = six;
													calculation (word);
												}
											i_six = 0;
										}
									i_five = 0;
								}
							i_four = 0;
						}
					i_three = 0;
				}
			i_two = 0;
		}
}	
